Index: typo3/mod/tools/em/class.em_soap.php
===================================================================
--- typo3/mod/tools/em/class.em_soap.php	(revision 4488)
+++ typo3/mod/tools/em/class.em_soap.php	(working copy)
@@ -43,14 +43,6 @@
 	 *                  'headers'   soap headers are used
 	 *                  'prefix'    function prefixes are used
 	 * prefix         : optional prefix to be put in front of all methods.
-	 * implementation : Which type of soap implementation to use :
-	 *                  'detect'    automatically detect an implementation.
-	 *                  'phpsoap'   PHP builtin SOAP module
-	 *                              <http://www.php.net/manual/en/ref.soap.php>
-	 *                  'nusoap'    NuSOAP class
-	 *                              <http://dietrich.ganx4.com/nusoap>
-	 *                  'pearsoap'  PEAR SOAP class
-	 *                              <http://pear.php.net/package/SOAP>
 	 * format         : Which type of return structure :
 	 *                  'object'    PHP objects
 	 *                  'array'     PHP arrays, default
@@ -58,9 +50,9 @@
 	var $options  = array();
 
 	/**
-	 * SOAP client depending on the available implementations, preferably the PHP SOAP class
+	 * SOAP client, instance of PHP SOAP class
 	 *
-	 * @var unknown_type
+	 * @var SoapClient
 	 */
 	var $client   = false;
 	var $error    = false;
@@ -87,35 +79,17 @@
 			}
 		}
 
-		if (!$options['implementation'] || $options['implementation'] == 'detect') {
-			if (defined('SOAP_1_2')) {
-				$options['implementation'] = 'phpsoap';
-			} elseif (class_exists('soapclient')) {
-				$options['implementation'] = 'nusoap';
-			} elseif (class_exists('SOAP_Client')) {
-				$options['implementation'] = 'pearsoap';
-			}
-		}
-
 		$options['format'] = $options['format'] == 'object' ? 'object' : 'array';
 
 		if ($options !== false) {
 			$this->options = (array)$options;
 		}
 
-		switch ($this->options['implementation']) {
-			case 'nusoap':
-				$this->client = new soapclient($this->options['wsdl'], true);
-				$this->client->getProxy();
-				break;
-			case 'pearsoap':
-				$this->client = new SOAP_Client($this->options['wsdl'], true);
-				break;
-			case 'phpsoap':
-				$this->client = new SoapClient($options['wsdl'],(array)$options['soapoptions']);
-				break;
-			default:
-				$this->client = false;
+		if (defined('SOAP_1_2')) {
+			$this->client = new SoapClient($options['wsdl'],(array)$options['soapoptions']);
+		} else {
+			throw new Exception('PHP soap extension not available');
+			$this->client = false;
 		}
 	}
 
@@ -166,8 +140,10 @@
 	 */
 	function call($func, $param=array(), $username=false, $password=false) {
 		if (!$this->client) {
-			$this->error = "Error in Webservices.class.php: No soap client implementation found. ".
-			"Make sure a SOAP library such as 'NuSoap.php' is included.";
+			$this->error = sprintf(
+				'Error in %s: No soap client implementation found. ' .
+				'Make sure PHP soap extension is available!', __FILE__
+			);
 			return false;
 		}
 
@@ -190,13 +166,7 @@
 
 		$this->error = false;
 
-		switch ($this->options['implementation']) {
-			case 'nusoap'   : return $this->callNuSOAP($func, $param); break;
-			case 'pearsoap' : return $this->callPearSOAP($func, $param); break;
-			case 'phpsoap'  : return $this->callPhpSOAP($func, $param); break;
-		}
-
-		return false;
+		return $this->callPhpSOAP($func, $param);
 	}
 
 	/**
@@ -243,94 +213,6 @@
 	/**
 	 * Enter description here...
 	 *
-	 * @param	unknown_type		$func
-	 * @param	unknown_type		$param
-	 * @return	unknown
-	 */
-	function callPearSOAP($func,$param) {
-		if ($this->options['authentication'] == 'headers') {
-			if ($this->reactid) {
-				$this->client->addHeader(
-				new SOAP_Header(
-				'HeaderAuthenticate', NULL,
-				array('reactid' => $this->reactid), 1
-				)
-				);
-			} elseif ($this->username && $this->password) {
-				$this->client->addHeader(
-				new SOAP_Header(
-				'HeaderLogin', NULL,
-				array(
-				'username' => $this->username,
-				'password' => $this->password
-				), 1
-				)
-				);
-				$this->password = false;
-			}
-		}
-
-
-		$result = $this->client->call($func, $param);
-
-		if (PEAR::isError($result)) {
-			$this->error = $result;
-			return false;
-		}
-
-		if (is_a($this->client->headersIn['HeaderAuthenticate'],'stdClass')) {
-			$this->reactid = $this->client->headersIn['HeaderAuthenticate']->reactid;
-		}
-
-		return $this->options['format'] == 'object' ? $result : $this->object2array($result);
-	}
-
-	/**
-	 * Enter description here...
-	 *
-	 * @param	unknown_type		$func
-	 * @param	unknown_type		$param
-	 * @return	unknown
-	 */
-	function callNuSOAP($func,$param) {
-		$header = false;
-		if ($this->options['authentication'] == 'headers') {
-			if ($this->reactid) {
-				$header = (
-				"<HeaderAuthenticate SOAP-ENV:mustUnderstand='1'>".
-				"<reactid>".htmlspecialchars($this->reactid)."</reactid>".
-				"</HeaderAuthenticate>"
-				);
-			} elseif ($this->username && $this->password) {
-				$header = (
-				"<HeaderLogin SOAP-ENV:mustUnderstand='1'>".
-				"<username>".htmlspecialchars($this->username)."</username>".
-				"<password>".htmlspecialchars($this->password)."</password>".
-				"</HeaderLogin>" //HeaderLogin
-				);
-				$this->password = false;
-			}
-		}
-
-		$result = $this->client->call($func, $param, false, false, $header);
-
-		if ($this->error = $this->client->getError()) {
-			return false;
-		}
-
-		// nusoap header support is very limited
-		$headers = $this->client->getHeaders();
-		$matches = array();
-		if (preg_match('~<([a-z0-9]+:)?reactid[^>]*>([^<]*)</([a-z0-9]+:)?reactid>~is', $headers, $matches)) {
-			$this->reactid = $matches[2];
-		}
-
-		return $this->options['format'] == 'object' ? $this->array2object($result) : $result;
-	}
-
-	/**
-	 * Enter description here...
-	 *
 	 * @param	unknown_type		$object
 	 * @return	unknown
 	 */
@@ -369,13 +251,8 @@
 	 * @return	unknown
 	 */
 	function lastRequest() {
-		switch ($this->options['implementation']) {
-			case 'nusoap'   : return $this->client->request; break;
-			case 'pearsoap' : return $this->client->__getlastrequest(); break;
-			case 'phpsoap'  : return $this->client->__getLastRequest(); break;
-		}
 
-		return false;
+		return $this->client->__getLastRequest();
 	}
 
 	/**
@@ -384,13 +261,8 @@
 	 * @return	unknown
 	 */
 	function lastResponse() {
-		switch ($this->options['implementation']) {
-			case 'nusoap'   : return $this->client->response; break;
-			case 'pearsoap' : return $this->client->__getlastresponse(); break;
-			case 'phpsoap'  : return $this->client->__getLastResponse(); break;
-		}
 
-		return false;
+		return $this->client->__getLastResponse();		
 	}
 
 	/**
@@ -399,13 +271,8 @@
 	 * @return	unknown
 	 */
 	function getFunctions() {
-		switch ($this->options['implementation']) {
-			case 'nusoap'   : return array_keys($this->client->operations); break;
-			case 'pearsoap' : return false; break;
-			case 'phpsoap'  : return $this->client->__getFunctions(); break;
-		}
 
-		return false;
+		return $this->client->__getFunctions();
 	}
 }
 
Index: typo3/mod/tools/em/class.em_terconnection.php
===================================================================
--- typo3/mod/tools/em/class.em_terconnection.php	(revision 4488)
+++ typo3/mod/tools/em/class.em_terconnection.php	(working copy)
@@ -27,10 +27,6 @@
 ***************************************************************/
 
 
-if (!defined('SOAP_1_2'))	{
-	require_once('class.nusoap.php');
-#	require_once('/usr/share/php/SOAP/Client.php');
-}
 require_once('class.em_soap.php');
 
 /**
@@ -298,7 +294,7 @@
 
 		$filesData = array();
 		foreach ($uArr['FILES'] as $filename => $infoArr) {
-			$content = (!defined('SOAP_1_2') && class_exists('soapclient')) ? base64_encode($infoArr['content']) : $infoArr['content']; // bug in NuSOAP - no automatic encoding
+			$content = $infoArr['content'];
 			$filesData['fileData'][] = array (
 				'name' => utf8_encode($infoArr['name']),
 				'size' => intval($infoArr['size']),
